// MTDriver.cpp: CMTDriver NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MTDriver.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define RETRY_READY		10			// Ready ̃gC

// VOL1 x
struct VOL1 {
	char	LabelID[4];				// xʖ
	char	VolumeID[6];			// {[ʖ
	char	Reserved1[31];			// gp
	char	Owner[10];				// L
	char	Reserved2[29];			// gp
};

// HDR1,EOF1,EOV1 x
struct LABEL1 {
	char	LabelID[4];				// xʖ
	char	FileID[17];				// t@Cʖ
	char	VolumeID[6];			// {[ʖ
	char	VolSeqNo[4];			// {[ԍ
	char	FileSeqNo[4];			// t@Cԍ
	char	GenerationNo[4];		// ԍ
	char	VersionNo[2];			// o[Wԍ
	char	CreationDate[6];		// 쐬t
	char	ExpirationDate[6];		// t
	char	Accessibility[1];		// @ی\
	char	BlockCount[6];			// ubN
	char	SystemCode[13];			// VXeʖ
	char	Reserved1[7];			// gp
};

// HDR2,EOF2,EOV2 x
struct LABEL2 {
	char	LabelID[4];				// xʖ
	char	RecordFormat[1];		// R[h`
	char	BlockLength[5];			// ubN
	char	RecordLength[5];		// R[h
	char	Density[1];				// L^x
	char	VolumeStatus[1];		// {[
	char	JobStep[17];			// Wu^Xebv
	char	Compressed[2];			// L^
	char	ControlChar[1];			// 䕶
	char	Reserved1[1];			// gp
	char	Blocking[1];			// ubN
	char	Reserved2[11];			// gp
	char	BufferOffet[2];			// obt@ItZbg
	char	Reserved3[28];			// gp
};

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CMTDriver::CMTDriver()
{
	m_hHandle = -1;
	m_nErrorCode = 0;
	m_nReadAhead = 0;
	m_pUpdateWnd = NULL;
	m_bBOT = TRUE;
}

CMTDriver::~CMTDriver()
{
	Close();
}

//
//	@\	F@MTI[v
//
//		F	nHAdapter - zXgA_v^ԍ
//				nScsiID - SCSI ID
//				nScsiLUN - SCSI LUN
//
//	Al	F	ʃR[h
//
//	@\F	MTũI[vsB
//
//	l	F	Ȃ
//
int CMTDriver::Open(int nHAdapter, int nScsiID, int nScsiLUN)
{
	int nResult;

	nResult = MT_open(nHAdapter, nScsiID, nScsiLUN);
	if (nResult >= 0) {
		m_hHandle = nResult;
		nResult = 0;
	} else
		m_nErrorCode = nResult;

	return nResult;
}

//
//	@\	F@MTN[Y
//
//		F	
//
//	Al	F	ʃR[h
//
//	@\F	MTũN[YsB
//
//	l	F	
//
int CMTDriver::Close()
{
	int nResult;

	if (m_hHandle != -1) {
		nResult = MT_close(m_hHandle);
		m_hHandle = -1;
	} else
		nResult = 0;

	return nResult;
}

//
//	@\	F@G[擾
//
//		F	sErrorMsg - G[bZ[W
//
//	Al	F	G[R[h
//
//	@\F	G[R[hƃG[bZ[W擾B
//
//	l	F	
//
int CMTDriver::GetError(CString &sErrorMsg)
{
	int nErrorCode;
	BYTE msg[256 + 1];

	nErrorCode = m_nErrorCode;
	MT_message2(nErrorCode, msg);
	sErrorMsg = msg;

	m_nErrorCode = 0;

	return nErrorCode;
}

//
//	@\	F@A[h
//
//		F	
//
//	Al	F	ʃR[h
//
//	@\F	MTA[hB
//
//	l	F	
//
int CMTDriver::Unload()
{
	int nResult;

	// A[h
	if ((nResult = MT_unload(m_hHandle, MT_OPERATE_STD, &m_StatusData)) < 0)
		m_nErrorCode = nResult;

	return nResult;
}

//
//	@\	F@Ch
//
//		F	
//
//	Al	F	ʃR[h
//
//	@\F	MTChB
//
//	l	F	
//
int CMTDriver::Rewind()
{
	int nResult;

	// Ch
	if ((nResult = MT_rewind(m_hHandle, MT_OPERATE_STD, &m_StatusData)) < 0)
		m_nErrorCode = nResult;

	return nResult;
}

//
//	@\	F@t@C}[Nݏ
//
//		F	nCount - ރt@C}[N̐
//
//	Al	F	ʃR[h
//
//	@\F	MTɎw肳ꂽt@C}[NށB
//
//	l	F	
//
int CMTDriver::WriteFmk(int nCount)
{
	int nResult;

	// t@C}[N
	if ((nResult = MT_writefmk(m_hHandle, nCount, &m_StatusData)) < 0)
		m_nErrorCode = nResult;

	return nResult;
}

//
//	@\	F@PubNǂݍݏ
//
//		F	
//
//	Al	F	ʃR[h
//
//	@\F	MTobt@ɂPubNǂݍށB
//
//	l	F	
//
int CMTDriver::Read()
{
	int nResult;

	// PubNǂݍ
	if ((nResult = MT_read(m_hHandle, m_IOBuf, BUF_SIZE, &m_StatusData)) < 0)
		m_nErrorCode = nResult;

	return nResult;
}

//
//	@\	F@PubNݏ
//
//		F	nDataLen - ރubN
//
//	Al	F	ʃR[h
//
//	@\F	MTɃobt@PubNށB
//
//	l	F	
//
int CMTDriver::Write(int nDataLen)
{
	int nResult;

	// PubN
	if ((nResult = MT_write(m_hHandle, m_IOBuf, nDataLen, &m_StatusData)) < 0)
		m_nErrorCode = nResult;

	return nResult;
}

//
//	@\	F@{[ʖ擾
//
//		F	sVolLabel - 擾ꂽ{[ʖ
//
//	Al	F	ʃR[h
//
//	@\F	MT{[ʖ擾B
//
//	l	F	
//
int CMTDriver::ReadVolumeLabel(CString &sVolLabel)
{
	int nResult;
	VOL1 *pVol1;

	// Ready ҂
	if ((nResult = WaitReady()) != 0)
		return nResult;

	// Ch
	if ((nResult = Rewind()) != 0)
		return nResult;

	// PubN(VOL1)ǂݍ
	if ((nResult = ReadConvert()) < 0)
		return nResult;

	// xʖ`FbN
	pVol1 = (VOL1 *)m_IOBuf;
	if (strncmp(pVol1->LabelID, "VOL1", 4) == 0)
		sVolLabel = CString(pVol1->VolumeID, sizeof(pVol1->VolumeID));
	else
		sVolLabel = "";

	return 0;
}

//
//	@\	F@݊Jn
//
//		F	
//
//	Al	F	ʃR[h
//
//	@\F	MTɏ݂sۂ̏B
//
//	l	F	
//
int CMTDriver::WriteStart()
{
	// t@CN[YĂȂN[Y
	if (m_File.m_hFile != CFile::hFileNull)
		m_File.Close();

	m_bBOT = TRUE;
	m_nVolSeqNo = 1;
	m_nFileSeqNo = 1;

	return 0;
}

//
//	@\	F@ݏI
//
//		F	
//
//	Al	F	ʃR[h
//
//	@\F	MTɏǏ㏈B
//
//	l	F	
//
int CMTDriver::WriteEnd()
{
	int nResult;

	WaitReady();

	// BOTʒuɖ΃e[v}[N
	if (!m_bBOT) {
		if ((nResult = WriteFmk(1)) != 0 && nResult != MT_FOUND_EOM)
			return nResult;
	}

	// A[h
	Unload();

	return 0;
}

//
//	@\	F@xLŃt@Cݏ
//
//		F	pFileName - ރfBXÑt@C
//				pFileID - t@Cʖ
//				pSystemID - VXeʖ
//				nRecordLength - R[h
//				nBlockingFactor - ubNW
//
//	Al	F	ʃR[h
//
//	@\F	w肳ꂽt@C̓eMTɃxLŏށB
//
//	l	F	
//
int CMTDriver::WriteFileWithLabel(LPCTSTR pFileName, LPCTSTR pFileID, LPCTSTR pSystemID, int nRecordLength, int nBlockingFactor)
{
	int nResult, nResult2;
	VOL1 *pVol1;

	m_sFileID = pFileID;
	m_sSystemID = pSystemID;
	m_nRecordLength = nRecordLength;
	m_nBlockingFactor = nBlockingFactor;
	m_nBlockLength = nRecordLength * nBlockingFactor;
	m_nBlockCount = 0;

	if (m_File.m_hFile == CFile::hFileNull) {
		if (!m_File.Open(pFileName, CFile::modeRead | CFile::shareDenyWrite))
			return RESULT_FILE_ERROR;

		m_sVolumeID = m_sVolumeID2;
		m_cVolumeStatus = '0';
	} else
		m_cVolumeStatus = '1';

	if (m_bBOT) {
		// Ready ҂
		if ((nResult = WaitReady()) != 0)
			return nResult;

		// Ch
		if ((nResult = Rewind()) != 0)
			return nResult;

		// PubN(VOL1)ǂݍ
		if ((nResult = ReadConvert()) < 0)
			return nResult;

		// {[ʖۑ
		pVol1 = (VOL1 *)m_IOBuf;
		m_sVolumeID2 = CString(pVol1->VolumeID, sizeof(pVol1->VolumeID));
		if (m_nVolSeqNo == 1)
			m_sVolumeID = m_sVolumeID2;

		m_bBOT = FALSE;
	}

	// HDR1
	if ((nResult = WriteLabel1("HDR1")) != 0)
		return nResult;

	// HDR2
	if ((nResult = WriteLabel2("HDR2")) != 0)
		return nResult;

	// e[v}[N
	if ((nResult = WriteFmk(1)) != 0)
		return nResult;

	// t@CRs[
	if ((nResult = WriteFileToMT()) < 0)
		return nResult;

	// e[v}[N
	if ((nResult2 = WriteFmk(1)) != 0 && nResult2 != MT_FOUND_EOM)
		return nResult2;

	if (nResult == RESULT_FILE_END) {
		// EOF1
		if ((nResult2 = WriteLabel1("EOF1")) != 0 && nResult2 != MT_FOUND_EOM)
			return nResult2;

		// EOF2
		if ((nResult2 = WriteLabel2("EOF2")) != 0 && nResult2 != MT_FOUND_EOM)
			return nResult2;

		// e[v}[N
		if ((nResult2 = WriteFmk(1)) != 0 && nResult2 != MT_FOUND_EOM)
			return nResult2;

		// Rs[t@CN[Y
		m_File.Close();

		// t@CԍXV
		m_nFileSeqNo++;
	} else if (nResult == RESULT_VOLUME_END) {
		// EOV1
		if ((nResult2 = WriteLabel1("EOV1")) != 0 && nResult2 != MT_FOUND_EOM)
			return nResult2;

		// EOV2
		if ((nResult2 = WriteLabel2("EOV2")) != 0 && nResult2 != MT_FOUND_EOM)
			return nResult2;

		// e[v}[N
		if ((nResult2 = WriteFmk(2)) != 0 && nResult2 != MT_FOUND_EOM)
			return nResult2;

		// A[h
		if ((nResult2 = Unload()) != 0)
			return nResult2;

		// {[ԍXV
		m_nVolSeqNo++;

		m_bBOT = TRUE;
	}

	return nResult;
}

//
//	@\	F@xŃt@Cݏ
//
//		F	pFileName - ރfBXÑt@C
//				nRecordLength - R[h
//				nBlockingFactor - ubNW
//
//	Al	F	ʃR[h
//
//	@\F	w肳ꂽt@C̓eMTɃxŏށB
//
//	l	F	
//
int CMTDriver::WriteFileNonLabel(LPCTSTR pFileName, int nRecordLength, int nBlockingFactor)
{
	int nResult, nResult2;

	// ubNݒ
	m_nBlockLength = nRecordLength * nBlockingFactor;

	// Rs[t@CI[v
	if (m_File.m_hFile == CFile::hFileNull) {
		if (!m_File.Open(pFileName, CFile::modeRead | CFile::shareDenyWrite))
			return RESULT_FILE_ERROR;
	}

	if (m_bBOT) {
		// Ready ҂
		if ((nResult = WaitReady()) != 0)
			return nResult;

		// Ch
		if ((nResult = Rewind()) != 0)
			return nResult;

		m_bBOT = FALSE;
	}

	// t@CRs[
	if ((nResult = WriteFileToMT()) < 0)
		return nResult;

	if (nResult == RESULT_FILE_END) {
		// e[v}[N
		if ((nResult2 = WriteFmk(1)) != 0 && nResult2 != MT_FOUND_EOM)
			return nResult2;

		// Rs[t@CN[Y
		m_File.Close();
	} else if (nResult == RESULT_VOLUME_END) {
		// e[v}[N
		if ((nResult2 = WriteFmk(2)) != 0 && nResult2 != MT_FOUND_EOM)
			return nResult2;

		// A[h
		if ((nResult2 = Unload()) != 0)
			return nResult2;

		m_bBOT = TRUE;
	}

	return nResult;
}

//
//	@\	F@xLŃt@Cǂݍݏ
//
//		F	pDirName - ރfBXÑfBNg
//
//	Al	F	ʃR[h
//
//	@\F	xLMTt@Cǂݍ݁Aw肳ꂽfBNgɏށB
//
//	l	F	
//
int CMTDriver::ReadFileWithLabel(LPCTSTR pDirName)
{
	int nResult, nResult2;
	VOL1 *pVol1;
	CString sFileID;
	CString sFileName;

	// Ch
	if ((nResult = Rewind()) != 0)
		return nResult;

	// PubN(VOL1)ǂݍ
	if ((nResult = ReadConvert()) < 0)
		return nResult;

	// "VOL1"̃`FbN
	pVol1 = (VOL1 *)m_IOBuf;
	if (CString(pVol1->LabelID, sizeof(pVol1->LabelID)) != "VOL1")
		return RESULT_MT_ERROR;

	while (true) {
		// wb_iHDR1,HDR2,TM)`FbN
		if ((nResult = CheckHeader(sFileID)) == MT_FOUND_FMK) {
			nResult = 0;
			break;
		} else if (nResult != 0)
			return nResult;

		// Rs[t@CI[v
		sFileName = (CString)pDirName + "\\" + sFileID;
		if (!m_File.Open(sFileName, CFile::modeCreate | CFile::modeNoTruncate | CFile::modeWrite | CFile::shareExclusive))
			return RESULT_FILE_ERROR;
		m_File.Seek(0, CFile::end);

		// t@CRs[
		if ((nResult = ReadFileFromMT()) != 0) {
			m_File.Close();
			return nResult;
		}

		// Rs[t@CN[Y
		m_File.Close();

		// EOF or EOV `FbN
		if ((nResult = CheckEOForEOV()) < 0)
			return nResult;

		// EOVȂ烋[v𔲂
		if (nResult == RESULT_VOLUME_END)
			break;
	}

	// A[h
	if ((nResult2 = Unload()) != 0)
		return nResult2;

	return nResult;
}

//
//	@\	F@xŃt@Cǂݍݏ
//
//		F	pFileName - ރfBXÑt@C
//
//	Al	F	ʃR[h
//
//	@\F	xMTt@Cǂݍ݁Aw肳ꂽt@CɏށB
//
//	l	F	
//
int CMTDriver::ReadFileNonLabel(LPCTSTR pFileName)
{
	int nResult;

	if (m_bBOT) {
		// Ready ҂
		if ((nResult = WaitReady()) != 0)
			return nResult;

		// Ch
		if ((nResult = Rewind()) != 0)
			return nResult;

		m_bBOT = FALSE;
	}

	// Rs[t@CI[v
	if (!m_File.Open(pFileName, CFile::modeCreate | CFile::modeNoTruncate | CFile::modeWrite | CFile::shareExclusive))
		return RESULT_FILE_ERROR;
	m_File.Seek(0, CFile::end);

	// t@CRs[
	if ((nResult = ReadFileFromMT()) != 0) {
		m_File.Close();
		return nResult;
	}

	// Rs[t@CN[Y
	m_File.Close();

	// e[v}[Ñ`FbN
	if ((nResult = Read()) == MT_FOUND_FMK || nResult == MT_KEY_MEDIUMERR) {
		// A[h
		if ((nResult = Unload()) != 0)
			return nResult;

		// {[I
		m_bBOT = TRUE;
		nResult = RESULT_VOLUME_END;
	} else if (nResult < 0) {
		// I/OG[
		return nResult;
	} else {
		// ǂ݃f[^ۑ
		m_nReadAhead = nResult;

		// t@CI
		nResult = RESULT_FILE_END;
	}

	return nResult;
}

//
//	@\	F@wb_(HDR1,HDR2,TM)̃`FbN
//
//		F	sFileID - wb_ɏꂽt@Cʖ
//
//	Al	F	ʃR[h
//
//	@\F	xLMTwb_ǂݍށB
//
//	l	F	
//
int CMTDriver::CheckHeader(CString &sFileID)
{
	int nResult;
	LABEL1 *pLabel1;
	LABEL2 *pLabel2;

	// PubN(HDR1)ǂݍ
	if ((nResult = ReadConvert()) < 0)
		return nResult;

	// "HDR1"̃`FbN
	pLabel1 = (LABEL1 *)m_IOBuf;
	if (CString(pLabel1->LabelID, sizeof(pLabel1->LabelID)) != "HDR1")
		return RESULT_MT_ERROR;

	// t@Cʖۑ
	sFileID = CString(pLabel1->FileID, sizeof(pLabel1->FileID));
	sFileID.TrimRight();

	// PubN(HDR2)ǂݍ
	if ((nResult = ReadConvert()) < 0)
		return nResult;

	// "HDR2"̃`FbN
	pLabel2 = (LABEL2 *)m_IOBuf;
	if (CString(pLabel2->LabelID, sizeof(pLabel2->LabelID)) != "HDR2")
		return RESULT_MT_ERROR;

	// e[v}[N`FbN
	if ((nResult = CheckTapeMark()) != 0)
		return nResult;

	return 0;
}

//
//	@\	F@EOF܂EOṼ`FbN
//
//		F	
//
//	Al	F	ʃR[h
//
//	@\F	xLMTEOF܂EOVǂݍށB
//
//	l	F	
//
int CMTDriver::CheckEOForEOV()
{
	int nResult;
	LABEL1 *pLabel1;
	LABEL2 *pLabel2;
	CString sHeader;

	// PubN(EOF1orEOV1)ǂݍ
	if ((nResult = ReadConvert()) < 0)
		return nResult;

	// "EOF1"or"EOV1"̃`FbN
	pLabel1 = (LABEL1 *)m_IOBuf;
	sHeader = CString(pLabel1->LabelID, sizeof(pLabel1->LabelID));
	if (sHeader == "EOF1") {
		// PubN(EOF2)ǂݍ
		if ((nResult = ReadConvert()) < 0)
			return nResult;

		// "EOF2"̃`FbN
		pLabel2 = (LABEL2 *)m_IOBuf;
		if (CString(pLabel2->LabelID, sizeof(pLabel2->LabelID)) != "EOF2")
			return RESULT_MT_ERROR;

		// e[v}[N`FbN
		if ((nResult = CheckTapeMark()) != 0)
			return nResult;

		return RESULT_FILE_END;
	} else if (sHeader == "EOV1") {
		// PubN(EOV2)ǂݍ
		if ((nResult = ReadConvert()) < 0)
			return nResult;

		// "EOV2"̃`FbN
		pLabel2 = (LABEL2 *)m_IOBuf;
		if (CString(pLabel2->LabelID, sizeof(pLabel2->LabelID)) != "EOV2")
			return RESULT_MT_ERROR;

		return RESULT_VOLUME_END;
	} else
		return RESULT_MT_ERROR;
}

//
//	@\	F@Ready҂
//
//		F	
//
//	Al	F	ʃR[h
//
//	@\F	MTuReadyɂȂ̂҂B
//
//	l	F	
//
int CMTDriver::WaitReady()
{
	int nResult;
	int i;

	// gC[v
	for (i = 0; i < RETRY_READY; i++) {
		// Ready`FbN
		if ((nResult = MT_ready(m_hHandle, &m_StatusData)) == 0)
			break;

		// Pb҂
		Sleep(1000);
	}

	if (nResult < 0)
		m_nErrorCode = nResult;

	return nResult;
}

//
//	@\	F@t@CMTɃRs[
//
//		F	
//
//	Al	F	ʃR[h
//
//	@\F	t@CMTɂPubNRs[B
//
//	l	F	
//
int CMTDriver::WriteFileToMT()
{
	int nResult;
	int nRead;

	// t@CPubNǂCMTɏ
	while ((nRead = m_File.Read(m_IOBuf, m_nBlockLength)) != 0) {
		m_nBlockCount++;
		if ((nResult = Write(nRead)) < 0) {
			if (nResult == MT_FOUND_EOM) {
				//m_File.Seek(-nRead, CFile::current);
				return RESULT_VOLUME_END;
			} else
				return nResult;
		}

		// Rs[̃EBhEXV
		if (m_pUpdateWnd != NULL)
			m_pUpdateWnd->UpdateWindow();
	}

	return RESULT_FILE_END;
}

//
//	@\	F@MTt@CɃRs[
//
//		F	
//
//	Al	F	ʃR[h
//
//	@\F	MTt@CɂPubNRs[B
//
//	l	F	
//
int CMTDriver::ReadFileFromMT()
{
	int nResult;

	// CMTPubNǂŃt@Cɏ
	while (true) {
		if (m_nReadAhead == 0) {
			// CMTPubNǂݍ
			if ((nResult = Read()) < 0)
				break;
		} else {
			// ǂ݂f[^
			nResult = m_nReadAhead;
			m_nReadAhead = 0;
		}

		try {
			m_File.Write(m_IOBuf, nResult);
		} catch (CFileException *fe) {
			fe->Delete();
			return RESULT_FILE_ERROR;
		}

		// Rs[̃EBhEXV
		if (m_pUpdateWnd != NULL)
			m_pUpdateWnd->UpdateWindow();

	}

	if (nResult != MT_FOUND_FMK)
		return nResult;

	return 0;
}

//
//	@\	F@HDR1,EOF1,EOV1ݏ
//
//		F	
//
//	Al	F	ʃR[h
//
//	@\F	HDR1܂EOF1܂EOV1MTɏށB
//
//	l	F	
//
int CMTDriver::WriteLabel1(LPCTSTR pLabelID)
{
	LABEL1 *pLabel;
	int nResult;

	// xPobt@Xy[XNA
	pLabel = (LABEL1 *)m_IOBuf;
	memset(pLabel, ' ', sizeof(LABEL1));

	// eڂ̃Zbg
	SetString(pLabel->LabelID, pLabelID);
	SetString(pLabel->FileID, m_sFileID);
	SetString(pLabel->VolumeID, m_sVolumeID);
	SetNumber(pLabel->VolSeqNo, m_nVolSeqNo, sizeof(pLabel->VolSeqNo));
	SetNumber(pLabel->FileSeqNo, m_nFileSeqNo, sizeof(pLabel->FileSeqNo));
	//SetString(pLabel->GenerationNo, "0000");
	// takazawa 20001031
	//SetString(pLabel->VersionNo, "00");
	SetSystemDate(pLabel->CreationDate);
	SetString(pLabel->ExpirationDate, " 00000");
	pLabel->Accessibility[0] = '0';
	SetNumber(pLabel->BlockCount, m_nBlockCount % 1000000, sizeof(pLabel->BlockCount));
	SetString(pLabel->SystemCode, m_sSystemID);

	// CMTɏ
	if ((nResult = WriteConvert(sizeof(LABEL1))) < 0)
		return nResult;

	return 0;
}

//
//	@\	F@HDR2,EOF2,EOV2ݏ
//
//		F	
//
//	Al	F	ʃR[h
//
//	@\F	HDR2܂EOF2܂EOV2MTɏށB
//
//	l	F	
//
int CMTDriver::WriteLabel2(LPCTSTR pLabelID)
{
	LABEL2 *pLabel;
	int nResult;

	// xQobt@Xy[XNA
	pLabel = (LABEL2 *)m_IOBuf;
	memset(pLabel, ' ', sizeof(LABEL2));

	// eڂ̃Zbg
	SetString(pLabel->LabelID, pLabelID);
	pLabel->RecordFormat[0] = 'F';
	SetNumber(pLabel->BlockLength, m_nBlockLength, sizeof(pLabel->BlockLength));
	SetNumber(pLabel->RecordLength, m_nRecordLength, sizeof(pLabel->RecordLength));
	pLabel->VolumeStatus[0] = m_cVolumeStatus;
	SetString(pLabel->JobStep, "Mt_Sys/Mt_Ctl");
	pLabel->Blocking[0] = (m_nRecordLength == m_nBlockLength) ? ' ' : 'B';

	// CMTɏ
	if ((nResult = WriteConvert(sizeof(LABEL2))) < 0)
		return nResult;

	return 0;
}

//
//	@\	F@Zbg
//
//		F	pBuf - obt@
//				pStr - Zbg镶
//
//	Al	F	
//
//	@\F	pBufpStr̒Rs[BiI['\0'͖j
//
//	l	F	
//
void CMTDriver::SetString(LPTSTR pBuf, LPCTSTR pStr)
{
	strncpy(pBuf, pStr, strlen(pStr));
}

//
//	@\	F@lZbg
//
//		F	pBuf - obt@
//				nNum - Zbg鐔l
//				nLength - 
//
//	Al	F	
//
//	@\F	l 9999 `Ńobt@ɃZbgB
//
//	l	F	
//
void CMTDriver::SetNumber(LPTSTR pBuf, int nNum, int nLength)
{
	CString sFmt, sNum;

	sFmt.Format("%%0%dd", nLength);
	sNum.Format(sFmt, nNum);
	strncpy(pBuf, sNum, nLength);
}

//
//	@\	F@VXetZbg
//
//		F	pBuf - obt@
//
//	Al	F	
//
//	@\F	obt@ɃVXetZbgB
//
//	l	F	
//
void CMTDriver::SetSystemDate(LPTSTR pBuf)
{
	CTime t = CTime::GetCurrentTime();
	CTimeSpan ts = t - CTime(t.GetYear(), 1, 1, 0, 0, 0);
	CString sDate;

	sDate.Format("%03d%03d", t.GetYear() % 1000, ts.GetDays() + 1);
	// takazawa
	strncpy(pBuf,sDate,6);
}

//
//	@\	F@PubNǂݍ݁R[hϊ
//
//		F	
//
//	Al	F	ʃR[h
//
//	@\F	MTPubNǂݍ݁AEBCDICJISɕϊB
//
//	l	F	
//
int CMTDriver::ReadConvert()
{
	int nResult;

	// PubNǂݍ
	if ((nResult = Read()) < 0)
		return nResult;

	// JISR[hɕϊ
	EbcdicToJis(m_IOBuf, nResult);

	return nResult;
}

//
//	@\	F@R[hϊPubNݏ
//
//		F	nBufSize - ރubN
//
//	Al	F	ʃR[h
//
//	@\F	obt@̓eJISEBCDICɕϊAMTɏށB
//
//	l	F	
//
int CMTDriver::WriteConvert(int nBufSize)
{
	// EBCDICR[hɕϊ
	JisToEbcdic(m_IOBuf, nBufSize);

	// CMTɏ
	return Write(nBufSize);
}

//
//	@\	F@e[v}[N`FbN
//
//		F	
//
//	Al	F	ʃR[h
//
//	@\F	Ƀe[v}[N݂邩`FbNB
//
//	l	F	
//
int CMTDriver::CheckTapeMark()
{
	int nResult;

	// PubNǂݍ
	if ((nResult = Read()) != MT_FOUND_FMK) {
		if (nResult < 0)
			return nResult;
		else
			return RESULT_MT_ERROR;
	}

	return 0;
}

//
//	@\	F@EBCDICJISɃR[hϊ
//
//		F	buf - obt@
//				len - buf Ƀf[^
//
//	Al	F	
//
//	@\F	obt@̓eEBCDICJISɃR[hϊB
//
//	l	F	
//
void CMTDriver::EbcdicToJis(BYTE *buf, int len)
{
	MT_convert(MT_CONV_EBCDIK_A8, buf, len);
}

//
//	@\	F@JISEBCDICɃR[hϊ
//
//		F	buf - obt@
//				len - buf Ƀf[^
//
//	Al	F	
//
//	@\F	obt@̓eJISEBCDICɃR[hϊB
//
//	l	F	
//
void CMTDriver::JisToEbcdic(BYTE *buf, int len)
{
	MT_convert(MT_CONV_A8_EBCDIK, buf, len);
}
